var LAST_ERROR = null;

function getFileExt(name) {
	var ext = "";
	try {
		var idx  = name.lastIndexOf(".");
		if (idx!=-1) {
			ext = (name.substr(idx+1, name.length - (idx+1))).toLowerCase();
		}
	} catch (e) {}
	return ext;	
}

function getDriveType(drv) {
   var out = "Unknown";
   
   switch (drv.DriveType) {
      case 0: out = "Unknown"; 	 break;
      case 1: out = "Removable"; break;
      case 2: out = "Fixed";     break;
      case 3: out = "Network";   break;
      case 4: out = "CD-ROM";    break;
      case 5: out = "RAM Disk";  break;
   }
   return out;
}

function getFileDirectory(name) {
	var ext = "";
	try {
		var idx  = name.lastIndexOf("\\");
		if (idx!=-1) {
			ext = (name.substr(0, idx)).toLowerCase();
		}
	} catch (e) {}
	return ext;	
}

function getFileMimeType(name) {
	var ext  = getFileExt(name);
	var mime = TBL_MIME[ext] ? TBL_MIME[ext] : "application/octet-stream";
	return mime;
}

function getFileText(name) {
	var text = "";
	var fso = new ActiveXObject("Scripting.FileSystemObject");
	try {
		var f  = fso.OpenTextFile(name, 1);
		text = f.ReadAll();
	} catch (e) {}
	
	return text;
}

function saveText(name, text) {
	var fso = new ActiveXObject("Scripting.FileSystemObject");
//	try {
		var f  = fso.OpenTextFile(name, 2);
		f.write(text);
//	} catch (e) {}
}

function createFolder(name) {
	var f   = null;
	var fso = new ActiveXObject("Scripting.FileSystemObject");
	try {
		f   = fso.CreateFolder(name);
	} catch (e) {
		LAST_ERROR = e.message;
	}
	return f;
}

function deleteFolder(name) {
	var fso = new ActiveXObject("Scripting.FileSystemObject");
	try {
		fso.DeleteFolder(name, true);
	} catch (e) {
		LAST_ERROR = e.message;	
	}
}

function deleteFile(name) {
	var fso = new ActiveXObject("Scripting.FileSystemObject");
	try {
		fso.DeleteFile(name, true);
	} catch (e) {
		LAST_ERROR = e.message;		
	}
}

function copyFolder(name, dest) {
	var fso = new ActiveXObject("Scripting.FileSystemObject");
	try {
		fso.CopyFolder(name, dest, true);
	} catch (e) {
		LAST_ERROR = e.message;	
	}
}

function copyFile(name, dest) {
	var fso = new ActiveXObject("Scripting.FileSystemObject");
	try {
		fso.CopyFile(name, dest, true);
	} catch (e) {
		LAST_ERROR = e.message;		
	}
}

function moveFolder(name, dest) {
	var fso = new ActiveXObject("Scripting.FileSystemObject");
	try {
		fso.MoveFolder(name, dest);
	} catch (e) {
		LAST_ERROR = e.message;	
	}
}

function moveFile(name, dest) {
	var fso = new ActiveXObject("Scripting.FileSystemObject");
	try {
		fso.MoveFile(name, dest);
	} catch (e) {
		LAST_ERROR = e.message;		
	}
}

function getLastError() {
	var err = LAST_ERROR;
	LAST_ERROR = null;
	return err;
}
