<?xml version="1.0"?>

<xsl:stylesheet 
      xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
      xmlns:msxsl="urn:schemas-microsoft-com:xslt"
	  xmlns:js="urn:schemas-microsoft-com:js"
      version="1.0">
	
	<xsl:output method="html" version="4.0"/>
	
	<msxsl:script language="JavaScript" implements-prefix="js">
		var IMG_PATH = "./Images/";
		
		function path2str(nodeList) {
			var text = nodeList.item(0).text;
			text = text.replace(/\\/g, "\\\\");			
			return text;
		}
		
		function getSize(nodeList) {
			var text = nodeList.item(0).text;
			var size = (new Number(parseInt(text)).toLocaleString());
			size = size.replace(/\.00$/, "");
			return size;
		}

		function getIcon(nodeList) {
			var text = nodeList.item(0).text;
			var icon = "none";
			try {
				var idx  = text.lastIndexOf(".");
				if (idx!=-1) {
					var ext = (text.substr(idx+1, text.length - (idx+1))).toLowerCase();
					switch (ext) {
						case "dll"   : icon = "dll" ; break;
						case "bat"   : icon = "bat" ; break;
						case "cmd"   : icon = "bat" ; break;
						case "exe"   : icon = "bat" ; break;
						case "com"   : icon = "bat" ; break;
						case "hlp"   : icon = "hlp" ; break;
						case "html"  : icon = "html"; break;
						case "htm"   : icon = "html"; break;
						case "asp"   : icon = "asp";  break;
						case "asa"   : icon = "asp";  break;
						case "css"   : icon = "css" ; break;
						case "ini"   : icon = "css" ; break;
						case "shtm"  : icon = "html"; break;
						case "shtml" : icon = "html"; break;
						case "log"   : icon = "txt" ; break;
						case "reg"   : icon = "reg" ; break;
						case "mp3"   : icon = "mp3" ; break;
						case "m3u"   : icon = "m3u" ; break;
						case "avi"   : icon = "avi" ; break;
						case "mpg"   : icon = "avi" ; break;
						case "mpeg"  : icon = "avi" ; break;
						case "asf"   : icon = "avi" ; break;
						case "wmv"   : icon = "avi" ; break;
						case "mov"   : icon = "mov" ; break;
						case "bmp"   : icon = "bmp" ; break;
						case "gif"   : icon = "gif" ; break;
						case "tif"   : icon = "tif" ; break;
						case "jpg"   : icon = "jpg" ; break;
						case "jpeg"  : icon = "jpg" ; break;
						case "js"    : icon = "js"  ; break;
						case "vbs"   : icon = "vbs" ; break;
						case "pl"    : icon = "pl"  ; break;
						case "zip"   : icon = "zip" ; break;
						case "cab"   : icon = "zip" ; break;
						case "rar"   : icon = "zip" ; break;
						case "arj"   : icon = "zip" ; break;
						case "doc"   : icon = "doc" ; break;
						case "wri"   : icon = "wri" ; break;
						case "eml"   : icon = "eml" ; break;
						case "txt"   : icon = "txt" ; break;
						case "ttf"   : icon = "ttf" ; break;
						case "xls"   : icon = "xls" ; break;
						case "xsl"   : icon = "xsl" ; break;
						case "xml"   : icon = "xsl" ; break;
					}
				}
			} catch (e) {}
		
			return IMG_PATH + "icon_" + icon +".gif";
		}
	</msxsl:script>
	
	<xsl:template match="/Response/CommandList">
		<xsl:apply-templates select="Command"/>
	</xsl:template>

	<xsl:template match="Command">
		<xsl:if test="Name[.='List']">
			<xsl:apply-templates select="Output"/>
		</xsl:if>
	</xsl:template>
	
	<xsl:template match="Output">
		<TABLE  border="0" cellspacing="0" cellpadding="0" type="FileTable" class="FileListTable" path="{./CurrentDirectory/Path}">
			<xsl:apply-templates select="ParentDirectory"/>
			<xsl:apply-templates select="Directory"/>
			<xsl:apply-templates select="File"/>
		</TABLE>
	</xsl:template>
	
	<xsl:template match="ParentDirectory">
		<xsl:variable name="id">
			<xsl:value-of select="generate-id(.)"/>
		</xsl:variable>
		<TR id="{$id}" path="{./Path}" class="FileListRow" type="folder" isParent="yes">
			<TD width="16" style="border:#FFFFFF 1px solid;border-right:#FFFFFF 0px solid;"><IMG src="./Images/icon_dir_up.gif"/></TD>
			<TD>[..]</TD>
			<TD style="padding-left:4px;">&lt;DIR&gt;</TD>
			<TD style="padding-left:4px;">
				<xsl:text disable-output-escaping="yes">&amp;</xsl:text>
				<xsl:text>nbsp;</xsl:text>
			</TD>
		</TR>
   </xsl:template>

	<xsl:template match="Directory">
		<xsl:variable name="id">
			<xsl:value-of select="generate-id(.)"/>
		</xsl:variable>
		<TR id="{$id}" path="{./Path}" class="FileListRow" type="folder" isParent="no">
			<TD width="16" style="border:#FFFFFF 1px solid;border-right:#FFFFFF 0px solid;"><IMG src="./Images/icon_dir.gif"/></TD>
			<TD>[<xsl:value-of select="./Name"/>]</TD>
			<TD style="padding-left:4px;">&lt;DIR&gt;</TD>
			<TD style="padding-left:4px;"><xsl:value-of select="DateLastModified"/></TD>
		</TR>
   </xsl:template>
   
	<xsl:template match="File">
		<xsl:variable name="id">
			<xsl:value-of select="generate-id(.)"/>
		</xsl:variable>
		<TR id="{$id}" class="FileListRow" type="file" path="{./Path}">
			<TD width="16" style="border:#FFFFFF 1px solid;border-right:#FFFFFF 0px solid;"><IMG src="{js:getIcon(./Name)}"/></TD>
			<TD><xsl:value-of select="./Name"/></TD>
			<TD style="padding-left:4px;"><xsl:value-of select="js:getSize(./Size)"/></TD>
			<TD style="padding-left:4px;"><xsl:value-of select="DateLastModified"/></TD>
		</TR>
   </xsl:template>

</xsl:stylesheet>
      