<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0"/>

	<xsl:template match="/">
		<xsl:apply-templates select="AddressLists"/>
	</xsl:template>

	<xsl:template match="AddressLists">
		<TABLE border="0" width="100%" class="Table_Title">
			<TR>
				<TD width="70%" class="Address_Label" align="right">Show names from the :</TD>
				<TD>
					<SELECT id="selList" onchange="hndOnSelect();" class="Address_Label">
						<xsl:apply-templates select="AddressList" mode="genSelect"/>
					</SELECT>
				</TD>
			</TR>
		</TABLE>
		<DIV id="cnLists" style="overflow:scroll;position:absolute;left:0px;margin:0px;padding:0px;">
			<xsl:apply-templates select="AddressList" mode="genTable"/>
		</DIV>	
	</xsl:template>

	<xsl:template match="AddressList" mode="genSelect">
		<xsl:variable name="id">
			<xsl:value-of select="generate-id(.)"/>
		</xsl:variable>
		<OPTION value="al_{$id}"><xsl:value-of select="Name"/></OPTION>
	</xsl:template>

	<xsl:template match="AddressList" mode="genTable">
		<xsl:variable name="id">
			<xsl:value-of select="generate-id(.)"/>
		</xsl:variable>
		<DIV id="al_{$id}" class="Address_List">
			<xsl:apply-templates select="AddressEntries"/>
		</DIV>
	</xsl:template>

	<xsl:template match="AddressEntries">
		<TABLE border="0" width="100%">
			<TR>
				<TD class="Table_Title">Name</TD>
				<TD class="Table_Title">Address</TD>
			</TR>
			<xsl:apply-templates select="AddressEntry"/>
		</TABLE>
	</xsl:template>

	<xsl:template match="AddressEntry">
		<TR>
			<TD nowrap="true" width="5%" class="Address_Label"><xsl:value-of select="Name"/></TD>
			<TD nowrap="true" class="Address_Label"><xsl:value-of select="Address"/></TD>
		</TR>
	</xsl:template>

 </xsl:stylesheet>
      