<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

	<xsl:output method="html" version="4.0"/>

	<xsl:template match="/">
		<xsl:apply-templates select="FolderList"/>
	</xsl:template>
	
	<xsl:template match="FolderList">
		<xsl:apply-templates select="Folder"/>
	</xsl:template>
	
	<xsl:template match="Folder">
		<xsl:variable name="id">
			<xsl:value-of select="generate-id(.)"/>
		</xsl:variable>
		
		<xsl:variable name="img_pref">
			<xsl:choose>
				<xsl:when test="following-sibling::node()">
					<xsl:choose>
						<xsl:when test="../.=/">
							<xsl:choose>
								<xsl:when test="preceding-sibling::node()">Tree_T</xsl:when>
								<xsl:otherwise>Tree_F</xsl:otherwise>
							</xsl:choose>
						</xsl:when>
						<xsl:otherwise>Tree_T</xsl:otherwise>
					</xsl:choose>
				</xsl:when>
				<xsl:otherwise>
					<xsl:choose>
						<xsl:when test="../.=/">Tree</xsl:when>
						<xsl:otherwise>Tree_L</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>

		
		<TABLE border="0" cellpadding="0" cellspacing="0">
			<TR id="tr1_{$id}">
				<xsl:choose>
					<xsl:when test="count(./FolderList/Folder)">
						<TD id="td1_{$id}"><IMG id="im_{$id}" src="./Images/{$img_pref}_Minus.gif" icnClose="./Images/{$img_pref}_Minus.gif" icnOpen="./Images/{$img_pref}_Plus.gif" width="19" height="16" isOpen="y" onclick="nodeSwitch(im_{$id}, tr2_{$id});"/></TD>
					</xsl:when>
					<xsl:otherwise>
						<xsl:choose>
							<xsl:when test="following-sibling::node()">
								<TD><IMG id="im_{$id}" src="./Images/Tree_T.gif" width="19" height="16"/></TD>
							</xsl:when>
							<xsl:otherwise>
								<TD><IMG id="im_{$id}" src="./Images/Tree_L.gif" width="19" height="16"/></TD>
							</xsl:otherwise>
						</xsl:choose>
						
					</xsl:otherwise>
				</xsl:choose>
				
				<TD id="td2_{$id}" path="{./Path}" onclick="nodeView(td2_{$id});" nowrap="true" labelID="label_{$id}">
					<TABLE border="0" cellpadding="0" cellspacing="0">
						<TR>
							<TD style="padding-right:3px;"><IMG src="./Images/TreeNode_Icon.gif" border="0"/></TD>
							<TD nowrap="true" id="label_{$id}" class="TreeNode_Label">
								<xsl:value-of select="./Name"/>
							</TD>
						</TR>
					</TABLE>
				</TD>				
			</TR>
			<TR id="tr2_{$id}" style="display:block;">
				<xsl:choose>
					<xsl:when test="following-sibling::node()">
						<TD style="background-image:URL(./Images/Tree_I.gif);background-repeat: repeat-y;"><IMG src="./Images/Spacer.gif" border="0" width="19" height="1"/></TD>
					</xsl:when>
					<xsl:otherwise>
						<TD><IMG src="./Images/Spacer.gif" border="0" width="19" height="1"/></TD>
					</xsl:otherwise>
				</xsl:choose>

				<TD>
					<xsl:apply-templates select="FolderList"/>
				</TD>
			</TR>
		</TABLE>
	</xsl:template>
	
 </xsl:stylesheet>
      