<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"  version="1.0">
	<xsl:import href="FolderTree2Html.xsl"/>
	<xsl:output method="html" version="4.0"/>

	<xsl:template match="/">
		<HTML>
			<HEAD>
				<META HTTP-EQUIV="MSThemeCompatible" CONTENT="Yes"/>
				<META HTTP-EQUIV="EXPIRES" CONTENT="0"/>
			</HEAD>
			<LINK rel="stylesheet" href="Style.css" type="text/css"/>
			
			<SCRIPT language="JScript">
			<![CDATA[
				var selectedNode   = null;	
				var pathBackup     = ".";
				
				function pgLoad() {
					selectedNode   = null;
					var tbl = cnFolderTree.childNodes.item(0);
					nodeView(tbl.rows[0].cells[1]);
				}
				
				function nodeSwitch(im, tr) {
					if (im.isOpen == "y") {
						im.src    = im.icnOpen;
						im.isOpen = "n";
						tr.style.display = "none";
					} else {
						im.src    = im.icnClose;
						im.isOpen = "y";
						tr.style.display = "block";
					}
				}			
				
				function nodeView(td) {
					try {
						if(selectedNode!= null) {
							document.all[selectedNode.labelID].className = "TreeNode_Label";
						}
						selectedNode = td;
						document.all[selectedNode.labelID].className = "TreeNode_Label_Selected";
						top.folderPath = selectedNode.path;
						loadMailList(pathBackup+selectedNode.path) 
					} catch (e) {}
				}
				
				function loadMailList(path) {
					top.frMailList.location = path + "/mail_index.xml.html";
				}
				
				function getBackupPath() {
					return pathBackup;
				}
			]]>
			</SCRIPT>
			
			<BODY onload="pgLoad()" style="padding:2px;margin:0px;">
				<DIV id="cnFolderTree">
					<xsl:apply-templates select="FolderList"/>
				</DIV>
			</BODY>
		</HTML>
	</xsl:template>
	
</xsl:stylesheet>
