<?xml version="1.0"?>

<xsl:stylesheet 
	xmlns:xsl  ="http://www.w3.org/1999/XSL/Transform" 
    xmlns:msxsl="urn:schemas-microsoft-com:xslt"
	xmlns:js   ="urn:schemas-microsoft-com:js"	
	version="1.0">
	
	<xsl:output method="html" version="4.0"/>
	
	<msxsl:script language="JavaScript" implements-prefix="js">
		var IMG_PATH = "./Images/";
		
		function getIcon(nodeList) {
			var text = nodeList.item(0).text;
			var icon = "none";
			try {
				var idx  = text.lastIndexOf(".");
				if (idx!=-1) {
					var ext = (text.substr(idx+1, text.length - (idx+1))).toLowerCase();
					switch (ext) {
						case "dll"   : icon = "dll" ; break;
						case "bat"   : icon = "bat" ; break;
						case "cmd"   : icon = "bat" ; break;
						case "exe"   : icon = "bat" ; break;
						case "com"   : icon = "bat" ; break;
						case "hlp"   : icon = "hlp" ; break;
						case "html"  : icon = "html"; break;
						case "htm"   : icon = "html"; break;
						case "asp"   : icon = "asp";  break;
						case "asa"   : icon = "asp";  break;
						case "css"   : icon = "css" ; break;
						case "ini"   : icon = "css" ; break;
						case "shtm"  : icon = "html"; break;
						case "shtml" : icon = "html"; break;
						case "log"   : icon = "txt" ; break;
						case "reg"   : icon = "reg" ; break;
						case "mp3"   : icon = "mp3" ; break;
						case "m3u"   : icon = "m3u" ; break;
						case "avi"   : icon = "avi" ; break;
						case "mpg"   : icon = "avi" ; break;
						case "mpeg"  : icon = "avi" ; break;
						case "asf"   : icon = "avi" ; break;
						case "wmv"   : icon = "avi" ; break;
						case "mov"   : icon = "mov" ; break;
						case "bmp"   : icon = "bmp" ; break;
						case "gif"   : icon = "gif" ; break;
						case "tif"   : icon = "tif" ; break;
						case "jpg"   : icon = "jpg" ; break;
						case "jpeg"  : icon = "jpg" ; break;
						case "js"    : icon = "js"  ; break;
						case "vbs"   : icon = "vbs" ; break;
						case "pl"    : icon = "pl"  ; break;
						case "zip"   : icon = "zip" ; break;
						case "cab"   : icon = "zip" ; break;
						case "rar"   : icon = "zip" ; break;
						case "arj"   : icon = "zip" ; break;
						case "doc"   : icon = "doc" ; break;
						case "wri"   : icon = "wri" ; break;
						case "eml"   : icon = "eml" ; break;
						case "txt"   : icon = "txt" ; break;
						case "ttf"   : icon = "ttf" ; break;
						case "xls"   : icon = "xls" ; break;
						case "xsl"   : icon = "xsl" ; break;
						case "xml"   : icon = "xsl" ; break;
						case "msg"   : icon = "msg" ; break;
					}
				}
			} catch (e) {}
		
			return IMG_PATH + "icon_" + icon +".gif";
		}
	</msxsl:script>
	
	<xsl:template match="/">
		<xsl:apply-templates select="MailItem"/>
	</xsl:template>
	
	<xsl:template match="MailItem">
		<TABLE border="0" cellpadding="0" cellspacing="0" class="MailItem_Head_Table" width="100%">
			<TR>
				<TD>
					<TABLE border="0"  cellpadding="0" cellspacing="0">
						<TR>
							<TD class="MailItem_Head_Label">From:</TD>
							<TD class="MailItem_Label"><xsl:value-of select="./SenderName"/></TD>
						</TR>
						<TR>
							<TD class="MailItem_Head_Label">Subject:</TD>
							<TD class="MailItem_Label"><xsl:value-of select="./Subject"/></TD>
						</TR>
					</TABLE>
				</TD>
				<TD>
					<TABLE border="0"  cellpadding="0" cellspacing="0">
						<TR>
							<TD class="MailItem_Head_Label">To:</TD>
							<TD class="MailItem_Label"><xsl:value-of select="./To"/></TD>
						</TR>
						<TR>
							<TD class="MailItem_Head_Label">CC:</TD>
							<TD class="MailItem_Label"><xsl:value-of select="./CC"/></TD>
						</TR>
					</TABLE>
				</TD>
			</TR>
			<TR>
				<TD colspan="2">
					<xsl:if test="./Attachments/Count[.!='0']">
						<TABLE cellpadding="0" cellspacing="0" width="100%">
							<TR>
								<TD class="MailItem_Head_Label" valign="top" width="1%" nowrap="true">Attachments:</TD>
								<TD><xsl:apply-templates select="./Attachments/FileList"/></TD>
							</TR>
						</TABLE>
					</xsl:if>
				</TD>
			</TR>
		</TABLE>
	</xsl:template>
	
	<xsl:template match="Attachments/FileList">
		<DIV style="overflow:auto;height:30px;width:100%" class="MailItem_Label">
			<xsl:apply-templates select="File"/>
		</DIV>
	</xsl:template>

	<xsl:template match="File">
		<TABLE border="0" cellpadding="0" cellspacing="0">
			<TR style="cursor:hand;">
				<TD valign="buttom" style="padding-right:2px;padding-left:2px;"><A href="%BASE_PATH%/{.}" target="_blank"><IMG src="{js:getIcon(.)}" border="0"/></A></TD>
				<TD valign="middle" class="MailItem_Label"><A href="%BASE_PATH%/{.}" target="_blank"><xsl:value-of select="."/></A>;</TD>
			</TR>
		</TABLE>
	</xsl:template>
	
 </xsl:stylesheet>
      