<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" version="4.0"/>

	<xsl:template match="/">
		<xsl:apply-templates select="MailList"/>
	</xsl:template>
	
	<xsl:template match="MailList">
		<TABLE id="tblMailList" border="0" cellpadding="0" cellspacing="0" width="100%">
			<xsl:apply-templates select="MailItem"/>
		</TABLE>
	</xsl:template>
	
	<xsl:template match="MailItem">
		<xsl:variable name="id">
			<xsl:value-of select="generate-id(.)"/>
		</xsl:variable>	
		<TR>
			<TD id="td_{$id}_top" colspan="7" class="MailItem_Row_H"><IMG src="./Images/Spacer.gif" height="1" width="1"/></TD>
		</TR>
		<TR id="tr_{$id}" onclick="selectRow(tr_{$id})" class="MailItem_Row" baseID="{$id}" path="{./Path}">
			<TD id="td_{$id}_left" class="MailItem_Row_V" width="1"><IMG src="./Images/Spacer.gif" height="1" width="1"/></TD>
			<TD width="1%"  class="MailItem_Icon"><IMG src="./Images/MailItem_Icon.gif"/></TD>
			<xsl:choose>
				<xsl:when test="./AttachmentsCount[.='0']">
					<TD width="1%" class="MailItem_Icon"><IMG src="./Images/Spacer.gif" width="8" height="12"/></TD>
				</xsl:when>
				<xsl:otherwise>
					<TD width="1%"  class="MailItem_Icon"><IMG src="./Images/MailItem_Attachment.gif" width="8" height="12"/></TD>
				</xsl:otherwise>
			</xsl:choose>
			<TD nowrap="true" width="1%" style="padding-left:3px;padding-right:3px;"><xsl:value-of select="./From"/></TD>
			<TD nowrap="true" style="padding-left:3px;padding-right:3px;"><xsl:value-of select="./Subject"/></TD>
			<TD nowrap="true" width="1%"><xsl:value-of select="./ReceivedTime"/></TD>
			<TD id="td_{$id}_right" class="MailItem_Row_V" width="1"><IMG src="./Images/Spacer.gif" height="1" width="1"/></TD>			
		</TR>
		<TR>
			<TD id="td_{$id}_bottom" colspan="7" class="MailItem_Row_H" height="1"><IMG src="./Images/Spacer.gif" height="1" width="1"/></TD>
		</TR>		
	</xsl:template>
	
 </xsl:stylesheet>
      