<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"  version="1.0">
	<xsl:import href="MailList2Html.xsl"/>
	<xsl:output method="html" version="4.0"/>

	<xsl:template match="/">
		<HTML>
			<HEAD>
				<META HTTP-EQUIV="MSThemeCompatible" CONTENT="Yes"/>
				<META HTTP-EQUIV="EXPIRES" CONTENT="0"/>
			</HEAD>
			<LINK rel="stylesheet" href="Style.css" type="text/css"/>
			
			<SCRIPT language="JScript">
			<![CDATA[
				var selectedRow    = null;
				var timeoutPreview = null;
				var timeoutLoad    = null;
				var pathMailList   = null;
				
				function pgLoad() {
					pgResize();
					selectFirst() ;
				}
				
				function loadListT(path) {
					try {
						top.frMailPreview.clearPane();
					} catch(e){}
					if(timeoutLoad!= null) {
						clearTimeout(timeoutLoad);
					}
					timeoutLoad = setTimeout("loadList('"+path+"')", 500);
				}
				
				function loadList(path) {
					self.location = path+"/mail_index.xml.html";
					pathMailList = path;
					selectedRow  = null;
				}
				
				function selectRow(tr) {
					try {
						if(selectedRow!= null) {
							selectedRow.className = "MailItem_Row";
							document.all['td_'+selectedRow.baseID+'_top'   ].className = "MailItem_Row_H";
							document.all['td_'+selectedRow.baseID+'_bottom'].className = "MailItem_Row_H";	
							document.all['td_'+selectedRow.baseID+'_left'  ].className = "MailItem_Row_V";			
							document.all['td_'+selectedRow.baseID+'_right' ].className = "MailItem_Row_V";			
						}
						selectedRow = tr;
						selectedRow.className = "MailItem_Row_Selected";
						document.all['td_'+selectedRow.baseID+'_top'   ].className = "MailItem_Row_H_Selected";
						document.all['td_'+selectedRow.baseID+'_bottom'].className = "MailItem_Row_H_Selected";	
						document.all['td_'+selectedRow.baseID+'_left'  ].className = "MailItem_Row_V_Selected";			
						document.all['td_'+selectedRow.baseID+'_right' ].className = "MailItem_Row_V_Selected";	
						loadMailItem(tr.path);
					} catch (e) {
						var path = (new String(top.location)).replace(/[^\/\\]*?\.html$/i, "");
						top.frMailPreview.location = path + "/mail.xml.html";
					}
				}
				
				function loadMailItem(path) {
					top.frMailPreview.location = new String(path).replace(/.*?(\/Mail\.\d+)/, ".$1")+"/mail.xml.html";
				}
				
				function selectFirst() {
					if (tblMailList.rows.length>2) {
						selectRow(tblMailList.rows[1])
					} else {
						var path = (new String(top.location)).replace(/[^\/\\]*?\.html$/i, "");
						top.frMailPreview.location = path + "/mail.xml.html";
					}
				}
				
				function selectGo(n) {
					if(selectedRow == null) {
						selectFirst() ;
					} else {
						var step = 3*n;
						var idx = selectedRow.rowIndex+step;
						idx = idx < 1 ? 1 : ( (idx>tblMailList.rows.length-2) ? (tblMailList.rows.length-2) : idx);
						selectRow(tblMailList.rows[idx])
					}
				}
				
				function pgKeyDown(evt) {
					evt = evt ? evt : window.event;
					var code  = evt.keyCode;
					switch (code) {
						case 38  : 
							selectGo(-1)
							break; // Up Arrow
						case 40 : 
							selectGo(1)
							break; // Down Arrow
						case 34 :
							selectGo(25);
							break; // Page down
						case 33 : 
							selectGo(-25);
							break; // Page up
					} 
					if ((code == 38)||(code == 40)||(code == 33)||(code == 34)) {
						evt.cancelBubble = true;
						evt.returnValue  = false;
						selectedRow.scrollIntoView(false);
						return false;
					}	
				
				}

				function pgResize() {
					cnMailList.style.pixelLeft   = 0;
					cnMailList.style.pixelTop    = 0;
					cnMailList.style.pixelWidth  = document.body.clientWidth ;
					cnMailList.style.pixelHeight = document.body.clientHeight;	
				}
			]]>
			</SCRIPT>
			
			<BODY onload="pgLoad();" onkeydown="pgKeyDown();" style="padding:0px;margin:0px;" onresize="pgResize();">
				<DIV id="cnMailList" style="position:absolute;overflow:auto;height:100%;width:100%;z-index:180;">
					<xsl:apply-templates select="MailList"/>
				</DIV>
			</BODY>
		</HTML>
	</xsl:template>
	
</xsl:stylesheet>			