<!-- #include virtual="/SCRIPTS/adovbs.inc" -->
<%

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'Name: RandomRecordSet
'Author: Nathan Arendt
'Created: Created April ?, 2001
'LastModified: April 24, 2001
'
'In: iNumber = maximum number of random records to select
'    sSelectField = The field used to select the selected random records from
'    the database. The field used should be the primary key.
'    sTable = the table to select the data from
'    sDatabasePath = the path and file name of the database (not the map path)
'    sExtraSQL = Extra SQL statments added after the main select argument. This
'    allows you to further limit the records from which random records are 
'    chosen i.e. you can add a WHERE Field = something statment or any orther
'    SQL statments that form a valid command.
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function RandomRecordSet(lNumber, sSelectField, sTable, sDatabasePath, sExtraSQL)
    Dim objConn, objRS
    Dim sSQL, sConnection, sFound, sSelectThese
    Dim lCount, lRndMax, lRndNumber
    
    sFound = ","
    
    sConnection="driver={Microsoft Access Driver (*.mdb)};dbq=" & sDatabasePath
    sSQL = "SELECT * FROM " & sTable & sExtraSQL & ";"
    
    Set objConn = Server.CreateObject("ADODB.Connection")
    Set objRS = Server.CreateObject("ADODB.Recordset")
   
    objConn.Open(sConnection)
    
    Call objRS.Open(sSQL, objConn, adOpenKeySet)
    
    If lNumber < objRS.RecordCount Then
        lCount = lNumber 
        lRndMax = objRS.RecordCount - 1
        
        Do Until lCount = -1
            Randomize
            lRndNumber = Clng(Rnd * lRndMax)
            If (InStr(1, sFound, "," & lRndNumber & "," ) = 0) Then
                sFound = sFound & lRndNumber & ","
                
                objRS.MoveFirst
                objRS.Move lRndNumber
                                                
                sSelectThese = sSelectThese & objRS(sSelectField) & ","
                
                lCount = lCount - 1
            End If    
        Loop

        objRS.Close
        Set objRS = Nothing

        sSql = "SELECT * FROM " & sTable & " WHERE (((InStr(1,'" & sSelectThese & _
               "',(','&" & sSelectField & "&',')))<>0)) "

        Set objRS = Server.CreateObject("ADODB.Recordset")
        Set objRS.ActiveConnection = objConn
        
        objRS.CursorType = adOpenKeySet
            
        objRS.Open(sSQL)
        
        Set RandomRecordSet = objRS
    Else
        
        Set RandomRecordSet = objRS
    End If
End Function

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'Name: RecordSetToString
'Author: Nathan Arendt
'Created: Created April 10, 2001
'LastModified: April 10, 2001
'
'In: objRS = the record set to make into a string
'    sRecordDelimiter = The character or string used to seperate the records
'    in the string.
'    sFieldDelimiter = The character or string used to seperate the fields of
'    individual records.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Function RecordSetToString(objRS, sRecordDelimiter, sFieldDelimiter)
    Dim iCount

    sRecordDelimiter = CStr(sRecordDelimiter)
    sFieldDelimiter = CStr(sFieldDelimiter)

    objRS.MoveFirst

    Do While Not objRS.EOF
        For iCount = 1 to objRS.Fields.Count - 1
            RecordSetToString = RecordSetToString & CStr(objRS.Fields(iCount) _
                                & sFieldDelimiter)
        Next

        'Trim the last field delimiter for this record
        If RecordSetToString <> "" And sFieldDelimiter <> "" Then
            RecordSetToString = Left(RecordSetToString, Len(RecordSetToString) _
                                - Len(sFieldDelimiter))
        End If

        RecordSetToString = RecordSetToString & sRecordDelimiter

        objRS.MoveNext
    Loop
    
    'Trim the last record delimiter for this record set
    If RecordSetToString <> "" And sRecordDelimiter <> "" Then 
        RecordSetToString = Left(RecordSetToString, Len(RecordSetToString) _
                            - Len(sRecordDelimiter))
    End If
End Function
%>