Attribute VB_Name = "modSMS"
'Author
'  mailto:klemens.schmid@gmx.de, http://www.schmidks.de
'
'Description
'  This is the next generation of my code firing SMS messages
'  programmatically. You can use three different services:
'
'  - http://www20.brinkster.com/zetsms/iwanbzsms.asp
'  - www.mtnsms.com
'  - www.icq.com
'
'  From these three samples you can learn how to deal with different
'  sites. Each sites uses different tricks to prevent us from
'  leveraging it.

'  Because the code does some screen scraping of
'  HTML pages it is fragile and may need to be adapted when the
'  underlying sites change. Please don't ask me to adapt it to
'  every such change except you want to pay me for the adaption.
'
'  Although presented in a VB project, the code is prepared for
'  running in an ASP page as well. You can simply cut/paste it
'  into an ASP page. For a better scalability you should use
'  adapt the lines maked with "'ASP".
'
'  My original plan to use Microsoft's XMLHTTP object as an HTTP
'  client couldn't be realized because of two deficiencies:
'  - You can't prevent XMLHTTP from following redirects
'  - In the case of a redirect XMLHTTP doesn't tell you the new site.
'  Therefore it used AspTear from http://www.alphasierrapapa.com.
'  I used the fifteen days trail version. This code only works with
'  AspTear 1.2 but not with 1.5. This is because 1.5 requires to set
'  cookies in a different manner. I will support this later.
'  AspTear 1.0, the free version, doesn't support properties required
'  here.
'  My code may also work with AspHttp from www.serverobjects.com
'  after some adaption.
'
'  A tool that helped my a lot finding out what the necessary requests
'  are is HttpTracer from http://www.concentric.net/~Sstmail/. Register
'  this tool. It's worthwhile.
'
'Prerequisites
'  The posting is done thru the ServerXMLHTTP object which is contained
'  in the Microsoft XML object msxml3.dll. Install this from
'  http://msdn.microsoft.com/xml/default.asp.
'
'  AspTear as mentioned above.
'
'  For convenience reasons I used the regular expression engine from
'  VBScript. With some effort you can get rid of it and do the checks
'  manually.

Option Explicit
Private mstrAspTearVersion 'As String

Public Function SendSms1(PhoneNumber, Text)
'Description
'  send SMS via the service http://www20.brinkster.com/zetsms/iwanbzsms.asp
'  This is a beta service and I can not recommend to use it for
'  production purposes. However, it is the only service that works
'  without registration. For that reason I believe that it will
'  either die or change soon.
'Parameters
'  PhoneNumber:   Where you want the SMS to be sent in the form +xxyyyzzzz..
'  Text:          The message text
'  Return:        0=ok, 2=logon failed, 3=submit failed

Dim strUrl 'As String                'the url
Dim strPost 'As String               'the current payload
'Dim oHttp 'As ServerXMLHTTP         'take this if you live on a W2K server
Dim oHttp 'As XMLHTTP                'take this otherwise

'templates
strUrl = "http://www20.brinkster.com/zetsms/iwanbzsms.asp"
strPost = "aksi=send&fName=&smsToNumbers=%phone%&FriendNumber=-&smsFrom=Foo&smsMessage=%text%"

'enter our data
strPost = Replace(strPost, "%phone%", UrlEncode(PhoneNumber))
strPost = Replace(strPost, "%text%", UrlEncode(Text))

'Create our http client
Set oHttp = CreateObject("msxml2.xmlhttp") 'VB
'Set oHttp = Server.CreateObject("msxml2.serverxmlhttp") 'ASP: take this if you live in on a W2K server

'fire of an http request to request for a cookie
oHttp.open "POST", strUrl, False
oHttp.setRequestHeader "Content-Type", "application/x-www-form-urlencoded"
oHttp.send strPost

'check response
Debug.Print oHttp.responseText
If InStr(oHttp.responseText, "Successfully sent") Then
   SendSms1 = 0
Else
   SendSms1 = 3
End If
End Function

Public Function SendSms2(User, Password, PhoneNumber, Text)
'Description
'  send SMS via the service www.mtnsms.com
'  This site requires you to register and logon
'  Issues a synchronous http request using the 'AspTear object
'  We can't use xmlhttp for this site because mtnsms return its
'  cookie with the first Http 302 response and msxml isn't able to catch this.
'Parameters
'  User:          The registered used ID
'  Password:      The associated password
'  PhoneNumber:   See SendSms1
'  Text:          See SendSms1
'  Return:        0=ok, 1=logon failed, 3=submit failed

Dim oHttp 'As ASPtear.ASPtear        'the http client
Dim strUrlPath 'As String            'the document part of the URL (without query string)
Dim strUrlTemp 'As String            'as returned from the request
Dim strLocation 'As String           'the url we are redirected to
Dim strServer 'As String             'the server part of the domain
Dim strPost 'As String               'the current payload
Dim strPost1 'As String              'payload of the first request
Dim strPost2 'As String              'payload of the second request
Dim strUrl 'As String                'the current request
Dim strUrl1 'As String               'first request
Dim strUrl2 'As String               'second request
Dim aCookies 'As Variant             'cookies returned from the first request
Dim strResponse 'As String           'current response
Dim vHeader 'As Variant              'loop vari
Dim i 'As integer
Dim p1 'As Integer,
Dim p2 'As Integer
Const METHOD_POST = 1
Const METHOD_GET = 2

'define message data
strUrl1 = "http://www.mtnsms.com/session.asp"
strUrl2 = "%server%.mtnsms.com/sms/xsms.asp"
strPost1 = "username=%user%&password=%pw%&email=&joinusclick=no&returl=&x=46&y=44"
strPost2 = "smsToCTs=&smsToNumbers=%phone%&smsMessage=%text%&smsSigDyna=%user%&lenSSig=23&lenLSig=23&lenSysSig=11"

'configure the request
Set oHttp = CreateObject("SOFTWING.ASPtear")
'Set oHttp = Server.CreateObject("SOFTWING.ASPtear") 'ASP: take this
'check version
On Error Resume Next
strResponse = oHttp.RedirectTarget
If Err.Number = 0 Then mstrAspTearVersion = "1.5"
On Error GoTo 0
'set connection params
oHttp.ConnectionTimeout = 5000
oHttp.FollowRedirects = False
oHttp.ContentType = "application/x-www-form-urlencoded"""
'assemble the payload
strPost = Replace(strPost1, "%user%", User)
strPost = Replace(strPost, "%pw%", Password)
'fire
On Error Resume Next
strResponse = oHttp.Retrieve(strUrl1, METHOD_POST, strPost, "", "")
Debug.Print oHttp.Headers
'check response
If InStr(oHttp.Headers, "err=") > 0 Then
   SendSms2 = 2 'logon failed
   Exit Function
End If
'get the server part of the redirected URL and the cookies
strLocation = GetHeader(oHttp.Headers, "location")(0)
p1 = InStr(strLocation, ".")
strServer = Left(strLocation, p1 - 1)
aCookies = GetHeader(oHttp.Headers, "set-cookie")
'send the redirected request
If mstrAspTearVersion = "1.5" Then
   'for version 1.5 we must set the cookies
   For Each vHeader In aCookies
      p1 = InStr(vHeader, "=")
      oHttp.AddCookie Left(vHeader, p1 - 1), Mid(vHeader, p1 + 1)
   Next
Else
   'for version 1.2 the http header from the previous retrieve is reused
End If
'fire
strResponse = oHttp.Retrieve(strLocation, METHOD_GET, "", "", "")
'prepare the main request thus submitting the SMS
strUrl = Replace(strUrl2, "%server%", strServer)
strPost = Replace(strPost2, "%user%", User)
strPost = Replace(strPost, "%phone%", PhoneNumber)
strPost = Replace(strPost, "%text%", Text)
If mstrAspTearVersion = "1.5" Then
   'for version 1.5 we must set the cookies
   For Each vHeader In aCookies
      p1 = InStr(vHeader, "=")
      oHttp.AddCookie Left(vHeader, p1 - 1), Mid(vHeader, p1 + 1)
   Next
Else
   'for version 1.2 the http header from the previous retrieve is reused
End If
oHttp.ContentType = "application/x-www-form-urlencoded"""
'fire
oHttp.FollowRedirects = False
oHttp.ConnectionTimeout = 5000
strResponse = oHttp.Retrieve(strUrl, METHOD_POST, strPost, "", "")
'check response
If InStr(strResponse, "message sent") Then
   SendSms2 = 0
Else
   SendSms2 = 3
End If

End Function

Public Function SendSms3(User, Password, PhoneNumber, Text)
'Send SMS via the service freemail.web.de
'Sorry, this no longer works because web.de applied another trick
'preventing us from using it programmatically.
'Although, it is a good sample of how to handle session id's

Dim oHttp 'As ASPtear.ASPtear        'the http client
Dim strSession 'As String            'the session string
Dim strServer 'As String             'the dynamic server part
Dim strResponse 'As String           'the http response
Dim strLocation 'As String           'the url we are redirected to
Dim strPost 'As String               'the current payload
Dim strPost1 'As String              'payload of the first request
Dim strPost2 'As String              'payload of the second request
Dim aPost() 'As Byte
Dim vPost 'As Variant
Dim strUrl 'As String                'the current request
Dim strUrl1 'As String               'first request
Dim strUrl2 'As String               'second request
Const METHOD_POST = 1
Const METHOD_GET = 2

'define message data
strUrl1 = "http://freemail.web.de/online/"
strUrl2 = "http://%server%.web.de/online/logic/action.htm"
strPost1 = "rv_uname=%user%&rv_passwd=%pw%&rv_dologon=%A0%A0Login%A0%A0"
strPost2 = "rv_do_savemsg=yes&rv_goto=/online/ordner/&rv_mid=94901421&rv_recover_user=dummy&si=%session%&msg_type=2&recover_dbserver&rv_smsnumber=%phone%&rv_subject=%text%&rv_counter=101&rv_do_send=Senden"
'prepare data
strPost = Replace(strPost1, "%user%", User)
strPost = Replace(strPost, "%pw%", Password)
'configure the request
Set oHttp = CreateObject("SOFTWING.ASPtear")
'Set oHttp = Server.CreateObject("SOFTWING.ASPtear") 'ASP: take this
'check version
On Error Resume Next
strResponse = oHttp.RedirectTarget
If Err.Number = 0 Then mstrAspTearVersion = "1.5"
On Error GoTo 0
'set connection params
oHttp.FollowRedirects = False 'must catch dynamic server
oHttp.ContentType = "application/x-www-form-urlencoded"
'fire
On Error Resume Next
strResponse = oHttp.Retrieve(strUrl1, METHOD_POST, strPost, "", "")
'check the feedback
Debug.Print oHttp.Headers
If InStr(strResponse, "Anmeldung fehlgeschlagen") > 0 Then
   SendSms3 = 2 'logon failed
   Exit Function
End If
'extract some stuff
strLocation = GetHeader(oHttp.Headers, "location")(0)
strServer = ExtractUrlServer(strLocation, "freemailng")
'follow redirect to get the session ID
oHttp.FollowRedirects = True
strResponse = oHttp.Retrieve(strLocation, METHOD_GET, "", "", "")
strSession = ExtractUrlParameter(strResponse, "si")
'assemble the payload
strUrl2 = Replace(strUrl2, "%server%", strServer)
strPost2 = Replace(strPost2, "%session%", strSession)
strPost2 = Replace(strPost2, "%phone%", PhoneNumber)
strPost2 = Replace(strPost2, "%text%", Text)
'do the actual send
Dim oXMLHttp 'As New XMLHTTP
Set oXMLHttp = CreateObject("msxml2.xmlhttp")
'Set oXMLHttp = CreateObject("msxml2.serverxmlhttp") 'ASP: take this if you live on a W2K server
oXMLHttp.open "POST", strUrl2, False
'oXMLHttp.setRequestHeader "Content-Type", "multipart/form-data; boundary=---6d94x"
oXMLHttp.setRequestHeader "Content-Type", "application/x-www-form-urlencoded"
vPost = strPost2
oXMLHttp.send vPost
'check response
strResponse = oXMLHttp.responseText
If InStr(strResponse, "wurde in unser System &uuml;bertragen") > 0 Then
   SendSms3 = 0
Else
   SendSms3 = 3
End If

End Function

Public Function SendSms4(User, Password, PhoneCountry, PhoneCarrier, PhoneNumber, Text)
'Description
'  Send SMS via the service www.icq.com
'  This site requires you to register and logon
'  This site doesn't use dynamic servers. But is uses redirection
'  and can therefore cannot be handled by xmlhttp.
'  It is the trickiest site handled here. I took me hour to replay.
'Parameters
'  User:          See SendSms2
'  Password:      See SendSms2
'  PhoneCountry:  The country part of the phone number. E.g 49
'  PhoneCarrier:  The carrier of area part of the phone number
'  Text:          The message text
'  Return:        1=ok, 2=logon failed

Dim oHttp 'As ASPtear.ASPtear        'the http client
Dim oXMLHttp 'As New XMLHTTP         'out HTTP client
Dim strSession 'As String            'the session string
Dim strServer 'As String             'the dynamic server part
Dim strResponse 'As String           'the http response
Dim strLocation 'As String           'the url we are redirected to
Dim strPost 'As String               'the current payload
Dim strPost1 'As String              'payload of the first request
Dim strPost2 'As String              'payload of the second request
Dim strPost3 'As String              'payload of the third request
Dim aPost() 'As Byte
Dim vPost 'As Variant
Dim strUrl 'As String                'the current request
Dim strUrl1 'As String               'first request
Dim strUrl2 'As String               'second request
Dim strUrl3 'As String               'third request
Dim strUrl4 'As String               'forth request
Dim aCookies 'As Variant             'cookies returned from the first request
Dim p
Dim vHeader 'As Variant
Const METHOD_POST = 1
Const METHOD_GET = 2

'define message data
strUrl1 = "http://web.icq.com/karma/dologin/1,,,00.html"
strPost1 = "uService=1&uLogin=%user%&uPassword=%pw%&x=17&y=8"
strUrl2 = "http://web.icq.com/sms/inbox/1,,,00.html?"
strUrl3 = "http://web.icq.com/sms/send_history/1,,,00.html"
strPost3 = "carrier=%carrier%&prefix=%country%&tophone=%number%&uSession=1&uReply=&uLastId=&uSend=1&uNextId=&uHistoryCounter=1&count=&uSubmitCount=0&uRefresh=0&checkNewMsg=180000&charcount=0&msg=%text%&x=13&y=19"
'prepare data
strPost1 = Replace(strPost1, "%user%", User)
strPost1 = Replace(strPost1, "%pw%", Password)
strPost3 = Replace(strPost3, "%country%", PhoneCountry)
strPost3 = Replace(strPost3, "%carrier%", PhoneCarrier)
strPost3 = Replace(strPost3, "%number%", PhoneNumber)
strPost3 = Replace(strPost3, "%text%", Text)
'prepare the request
Set oHttp = CreateObject("SOFTWING.AspTear")
'Set oHttp = Server.CreateObject("SOFTWING.AspTear") 'ASP: take this
'check version
On Error Resume Next
strResponse = oHttp.RedirectTarget
If Err.Number = 0 Then mstrAspTearVersion = "1.5"
On Error GoTo 0
'set connection params
oHttp.FollowRedirects = False 'must catch dynamic server
oHttp.ContentType = "application/x-www-form-urlencoded"
'fire
On Error Resume Next
strResponse = oHttp.Retrieve(strUrl1, METHOD_POST, strPost1, "", "")
aCookies = GetHeader(oHttp.Headers, "set-cookie")
'check the feedback
Debug.Print oHttp.Headers
'follow the redirect. Why idea why this is required but it is
'prepare the request
If mstrAspTearVersion = "1.5" Then
   'for version 1.5 we must set the cookies
   For Each vHeader In aCookies
      If InStr(vHeader, "icq.com") > 0 Then
         p = InStr(vHeader, "=")
         oHttp.AddCookie Left(vHeader, p - 1), Mid(vHeader, p + 1)
      End If
   Next
Else
   'for version 1.2 the http header from the previous retrieve is reused
End If
'fire
On Error Resume Next
strResponse = oHttp.Retrieve(strUrl2, METHOD_GET, "", "", "")
If InStr(strResponse, "Login to Your") > 0 Then
   SendSms4 = 2 'logon failed
   Exit Function
End If
'the main request
'configure the request
oHttp.FollowRedirects = False
oHttp.ContentType = "application/x-www-form-urlencoded"
If mstrAspTearVersion = "1.5" Then
   'for version 1.5 we must set the cookies
   For Each vHeader In aCookies
      If InStr(vHeader, "icq.com") > 0 Then
         p = InStr(vHeader, "=")
         oHttp.AddCookie Left(vHeader, p - 1), Mid(vHeader, p + 1)
      End If
   Next
Else
   'for version 1.2 the http header from the previous retrieve is reused
End If
'fire
On Error Resume Next
strResponse = oHttp.Retrieve(strUrl3, METHOD_POST, strPost3, "", "")
'check the feedback - there is no way here
SendSms4 = 1

End Function

'Private Function GetHeader(ByVal Headers As String, ByVal Name 's String) As Variant
Private Function GetHeader(ByVal Headers, ByVal Name)
'extract a single header from the all-headers-string
'returns an array. Array contains at least 1 empty element
'if a header occurs multiple time the array contains >1 elements

Dim p1 'As Integer
Dim p2 'As Integer
Dim cnt 'As Integer
Dim vResult() 'As String

'make sure the array is always filled
cnt = -1: p2 = 1
ReDim vResult(0)
Do While p2 <= Len(Headers)
   'locate
   p1 = InStr(p2, LCase(Headers), LCase(Name) & ":")
   If p1 = 0 Then Exit Do
   p1 = p1 + Len(Name) + 1
   'find end
   p2 = InStr(p1, Headers, vbCrLf)
   If p2 = 0 Then p2 = Len(Headers) + 1
   'extract
   cnt = cnt + 1
   If cnt > 0 Then
      ReDim Preserve vResult(cnt)
   End If
   vResult(cnt) = Trim(Mid(Headers, p1, p2 - p1))
Loop
'return
GetHeader = vResult
End Function

'Private Function ExtractUrlParameter(ByRef Source As String, ByVal ParamName As String) As String
Private Function ExtractUrlParameter(ByRef Source, ByVal ParamName)
'extract a parameter like ...&p1=432.54fs342.435&p2=... from an HTML source
Dim oRegExp 'As RegExp
Dim oMatchCol 'As MatchCollection

'init
Set oRegExp = CreateObject("VBScript.RegExp")
'Set oRegExp = Server.CreateObject("VBScript.RegExp") 'ASP: take this
oRegExp.IgnoreCase = True
oRegExp.Global = True
'extract
oRegExp.Pattern = ParamName & "=(.+?)(?:""|&|/|>|\s)"
Set oMatchCol = oRegExp.Execute(Source)
If oMatchCol.Count > 0 Then
   On Error Resume Next
   ExtractUrlParameter = oMatchCol(0).SubMatches(0)
End If

End Function

'Private Function ExtractUrlServer(ByVal Url As String, ByVal FixedPortion As String) As String
Private Function ExtractUrlServer(ByVal Url, ByVal FixedPortion)
'extract the server part of an URL
Dim oRegExp 'As RegExp
Dim oMatchCol 'As MatchCollection
Dim strPattern 'As String

'init
strPattern = "http://(%fixed%\w+)\."
strPattern = Replace(strPattern, "%fixed%", FixedPortion)
Set oRegExp = CreateObject("VBScript.RegExp")
'Set oRegExp = Server.CreateObject("VBScript.RegExp") 'ASP: take this
oRegExp.IgnoreCase = True
oRegExp.Global = True
'extract
oRegExp.Pattern = strPattern
Set oMatchCol = oRegExp.Execute(Url)
If oMatchCol.Count > 0 Then
   On Error Resume Next
   ExtractUrlServer = oMatchCol(0).SubMatches(0)
End If

End Function

'Private Function UrlEncode(ByVal s As String) As String
Private Function UrlEncode(ByVal s)
'This function converts non-alphanumeric characters to their
'hexadecimal equivalents, 'As required by http protocol.

Dim sTemp 'As String
Dim sAns 'As String
Dim ch 'As String
Dim i 'As Long

s = Replace(s, "%", "%25")
s = Replace(s, "+", "%2B")
s = Replace(s, " ", "+")
For i = 1 To Len(s)
   ch = Mid(s, i, 1)
   'is it alphanumeric?
   'The test is circumstancial to make it run in VBS as well
   Select Case ch
      Case "+", "%", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9"
         sTemp = sTemp & ch
      Case Else
         If ch >= "a" And ch <= "z" Or ch >= "A" And ch <= "Z" Then
            sTemp = sTemp & ch
         Else
            sTemp = sTemp & "%" & Right("0" & Hex(Asc(ch)), 2)
         End If
   End Select
   If Len(sTemp) > 1000 Then
       sAns = sAns & sTemp
       sTemp = ""
   End If
Next

UrlEncode = sAns & sTemp

End Function

