<?xml version="1.0"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:msxsl="urn:schemas-microsoft-com:xslt"
	xmlns:ps_js="http://www.postscriptum.gr/js_namespace">

	<msxsl:script language="javascript" implements-prefix="ps_js"><![CDATA[
		function convertTimestamp(sTimestamp) {
			var sDate = sTimestamp.substr(0, 10);
			if (sDate != "")
				return sDate.substr(8,2) + "/" + sDate.substr(5,2) + "/" + sDate.substr(0,4) ;
			else
				return sTimestamp;
		}
		
		function imageExt(fName) {
			var ext="";
			var i = fName.lastIndexOf('.');
			if (i != -1)
				ext=fName.substr(i+1).toLowerCase();
			return ext;
		}

		function isImage(fName) {
			var ext=imageExt(fName);
			return (ext == "jpg") || (ext=="gif");
		}

		function fileType(fName) {
			var ext = imageExt(fName);
			switch (ext) {
				case "bmp": return "Windows Bitmap Image";
				case "doc": return "Microsoft Word Document";
				case "gif": return "GIF Image";
				case "jpg": return "JPEG Image";
				case "pdf": return "Adobe PDF Document";
				case "ppt": return "Microsoft PowerPoint Document";
				case "txt": return "Text file";
				case "xls": return "Microsoft Excel Document";
				case "zip": return "Compressed ZIP file";
				default: return "Unknown File Type (" + ext.toUpperCase() +")";
			}
		}

		function imageTag(nodeList) {
			var s = nodeList.nextNode().nodeValue;
			if (isImage(s))
				return '<IMG height="100" width="100" src="' + s + '"</IMG>';
			else
				return fileType(s);
		}
		
	]]></msxsl:script>

</xsl:stylesheet>
