<%
function LookUpProvider(IP)
	
	' code partually from Eric Green's Whois/whereis script.
	' it uses the same method for retrieving the whois queries
	' but the way the returned stuff is handled is different.
	' Anyway, I thought it would be nice to mention him.

	' IP: takes the IP address to lookup
	' returns the name of the provider who is associated 
	' with the ip address (eg. Belgacom Skynet SA/NV)


	dim objXML, strXML, strURL, strData, x, y, range

	' build first url (ARIN)
	strURL="http://ws.arin.net/cgi-bin/whois.pl?queryinput=" & IP

	Set objXML = CreateObject("Microsoft.XMLHTTP")
	objXML.Open "GET", strURL, False
	objXML.Send	
	strXML = objXML.ResponseText

	x=instrrev(ucase(strXML),"<PRE>")+7
	y=instr(1,ucase(strXML),"</PRE>")

	' get the part of the page that is actually interesting for us
	strData=mid(strXML,x,y-x)

	If ucase(Left(strData,35)) = "EUROPEAN REGIONAL INTERNET REGISTRY" then

		' European address, use RIPE instead

		strURL="http://www.ripe.net/perl/whois?searchtext=" & IP
		objXML.Open "GET", strURL, False
		objXML.Send	
		strXML = objXML.ResponseText

		x=instr(ucase(strXML),"<PRE>")+5
		x=instr(x,ucase(strXML),"<PRE>")+5
		y=instr(x,ucase(strXML),"</PRE>")

		strData=mid(strXML,x,y-x)

		' find the first DESCR block, which contains the name of the provider
		x = instr(ucase(strData),"DESCR") + 7
		y = instr(x,strData,vbLf)

		LookUpProvider = trim(mid(strData,x,y-x))

	elseif ucase(left(strdata,39)) = "ASIA PACIFIC NETWORK INFORMATION CENTER" then

		' Asian or Pasific, use APNIC
		strURL = "http://www.apnic.net/apnic-bin/whois2.pl?results=all&search=" & IP
		objXML.Open "GET", strURL, False
		objXML.Send	
		strXML = objXML.ResponseText

		x=instrrev(ucase(strXML),"<PRE>")+7
		y=instr(x,ucase(strXML),"</PRE>")

		strData=mid(strXML,x,y-x)

		x=instr(ucase(strData),"INETNUM")+7
		if x <> 7 Then
			x=instr(strData,">")+1
			y=instr(x,strData,"<")
			
			range = trim(mid(strData,x,y-x))

			' check IP range
			if range = "210.136.0.0 - 210.143.255.255" then
				' Japan Network Information Center, real thing is next inetnum
				x=instr(x,ucase(strData),"INETNUM")
			end if

			' get DESCR, which contains name of provider
			x = instr(x,ucase(strData),"DESCR") + 5
			y = instr(x,strData,vbLf)

			LookUpProvider = trim(mid(strData,x,y-x))
			
		else
			LookUpProvider = "Unknown"
		end if

	else
		' American, so it should be the first part 
		LookupProvider = trim(left(strdata,instr(strData,"(")-1))
	end if

End Function
%>